<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content component">
                   <div class="content-data">




<ol class="breadcrumb">
  <li>Components</li>
  <li>BallotsListComponent</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
        <li >
            <a href="#templateData" role="tab" id="templateData-tab" data-toggle="tab" data-link="template">Template</a>
        </li>
        <li >
            <a href="#styleData" role="tab" id="styleData-tab" data-toggle="tab" data-link="style">Styles</a>
        </li>
        <li >
            <a href="#tree" role="tab" id="tree-tab" data-toggle="tab" data-link="dom-tree">DOM Tree</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info"><p class="comment">
    <h3>File</h3>
</p>
<p class="comment">
    <code>src/app/operation/3-ballots-list/ballots-list.component.ts</code>
</p>



    <p class="comment">
        <h3>Implements</h3>
    </p>
    <p class="comment">
                <code><a href="https://angular.io/api/core/OnInit" target="_blank" >OnInit</a></code>
                <code><a href="https://angular.io/api/core/OnDestroy" target="_blank" >OnDestroy</a></code>
    </p>


<section>
    <h3>Metadata</h3>
    <table class="table table-sm table-hover">
        <tbody>











            <tr>
                <td class="col-md-3">selector</td>
                <td class="col-md-9"><code>app-ballots-list</code></td>
            </tr>

            <tr>
                <td class="col-md-3">styleUrls</td>
                <td class="col-md-9"><code>./ballots-list.component.scss</code></td>
            </tr>



            <tr>
                <td class="col-md-3">templateUrl</td>
                <td class="col-md-9"><code>./ballots-list.component.html</code></td>
            </tr>








        </tbody>
    </table>
</section>

    <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#changeSubscription">changeSubscription</a>
                            </li>
                            <li>
                                <a href="#currentStepNumber">currentStepNumber</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#filledBallotsCounter">filledBallotsCounter</a>
                            </li>
                            <li>
                                <a href="#nextStepNumber">nextStepNumber</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#continue">continue</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#countVoted">countVoted</a>
                            </li>
                            <li>
                                <a href="#ngOnDestroy">ngOnDestroy</a>
                            </li>
                            <li>
                                <a href="#ngOnInit">ngOnInit</a>
                            </li>
                            <li>
                                <a href="#quit">quit</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#update">update</a>
                            </li>
                        </ul>
                    </td>
                </tr>





                    <tr>
                        <td class="col-md-4">
                            <h6><b>Accessors</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                    <a href="#votations">votations</a>
                                </li>
                                <li>
                                    <a href="#elections">elections</a>
                                </li>
                                <li>
                                    <a href="#groupVotation">groupVotation</a>
                                </li>
                                <li>
                                    <a href="#counts">counts</a>
                                </li>
                                <li>
                                    <a href="#totalBallotsCounter">totalBallotsCounter</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
        </tbody>
    </table>
</section>

    <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(router: <a href="https://angular.io/api/router/Router" target="_blank">Router</a>, route: <a href="https://angular.io/api/router/ActivatedRoute" target="_blank">ActivatedRoute</a>, voteWorkflowViewComponent: <a href="../components/VoteWorkflowViewComponent.html">VoteWorkflowViewComponent</a>, currentVotingService: <a href="../injectables/CurrentVotingService.html">CurrentVotingService</a>, dialog: MatDialog)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="44" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:44</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>router</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/router/Router" target="_blank" >Router</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>route</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/router/ActivatedRoute" target="_blank" >ActivatedRoute</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>voteWorkflowViewComponent</td>
                                                  
                                                        <td>
                                                                    <code><a href="../components/VoteWorkflowViewComponent.html" target="_self" >VoteWorkflowViewComponent</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>currentVotingService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/CurrentVotingService.html" target="_self" >CurrentVotingService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>dialog</td>
                                                  
                                                        <td>
                                                                    <code>MatDialog</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>





    <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="continue"></a>
                        <span class="name">
                            <b>
                            continue
                            </b>
                            <a href="#continue"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>continue()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="81" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:81</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="countVoted"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            countVoted
                            </b>
                            <a href="#countVoted"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>countVoted(ballots: <a href="../classes/Ballot.html">Ballot[]</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="143" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:143</a></div>
                            </td>
                        </tr>

                        <tr>
                            <td class="col-md-4">
                                <b>Type parameters :</b>
                                <ul class="type-parameters">
                                        <li>Ballot</li>
                                </ul>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>ballots</td>
                                                        <td>
                                                                    <code><a href="../classes/Ballot.html" target="_self" >Ballot[]</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnDestroy"></a>
                        <span class="name">
                            <b>
                            ngOnDestroy
                            </b>
                            <a href="#ngOnDestroy"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnDestroy()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="74" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:74</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnInit"></a>
                        <span class="name">
                            <b>
                            ngOnInit
                            </b>
                            <a href="#ngOnInit"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnInit()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="65" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:65</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="quit"></a>
                        <span class="name">
                            <b>
                            quit
                            </b>
                            <a href="#quit"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>quit()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="78" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:78</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="update"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            update
                            </b>
                            <a href="#update"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>update()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="131" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:131</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

    <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="changeSubscription"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            changeSubscription
                            </b>
                            <a href="#changeSubscription"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>changeSubscription:     <code>Subscription</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Subscription</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="43" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:43</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="currentStepNumber"></a>
                        <span class="name">
                            <b>
                            currentStepNumber
                            </b>
                            <a href="#currentStepNumber"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>currentStepNumber:     <code></code>
</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="41" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:41</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="filledBallotsCounter"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            filledBallotsCounter
                            </b>
                            <a href="#filledBallotsCounter"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>filledBallotsCounter:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="44" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:44</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="nextStepNumber"></a>
                        <span class="name">
                            <b>
                            nextStepNumber
                            </b>
                            <a href="#nextStepNumber"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>nextStepNumber:     <code></code>
</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="42" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:42</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    <section>
    <h3 id="accessors">
        Accessors
    </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="votations"></a>
                        <span class="name"><b>votations</b><a href="#votations"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>votations()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="53" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:53</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="elections"></a>
                        <span class="name"><b>elections</b><a href="#elections"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>elections()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="57" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:57</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="groupVotation"></a>
                        <span class="name"><b>groupVotation</b><a href="#groupVotation"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>groupVotation()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="61" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:61</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="counts"></a>
                        <span class="name"><b>counts</b><a href="#counts"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>counts()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="115" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:115</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="totalBallotsCounter"></a>
                        <span class="name"><b>totalBallotsCounter</b><a href="#totalBallotsCounter"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>totalBallotsCounter()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="122" class="link-to-prism">src/app/operation/3-ballots-list/ballots-list.component.ts:122</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
</section>
</div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnDestroy, OnInit } from &#x27;@angular/core&#x27;;
import { Step, VoteWorkflowViewComponent } from &#x27;../vote-workflow-display/vote-workflow-view.component&#x27;;
import { CurrentVotingService } from &#x27;../current-voting-service&#x27;;
import { Subscription } from &#x27;rxjs&#x27;;
import { ElectionBallot } from &#x27;../../model/election&#x27;;
import { Votation } from &#x27;../../model/votation&#x27;;
import { ActivatedRoute, Router } from &#x27;@angular/router&#x27;;
import { MatDialog } from &#x27;@angular/material&#x27;;
import { ChvoteDialogComponent } from &#x27;../../core/chvote-dialog/chvote-dialog.component&#x27;;

@Component({
  selector: &#x27;app-ballots-list&#x27;,
  templateUrl: &#x27;./ballots-list.component.html&#x27;,
  styleUrls: [&#x27;./ballots-list.component.scss&#x27;]
})

export class BallotsListComponent implements OnInit, OnDestroy {
  currentStepNumber;
  nextStepNumber;
  private changeSubscription: Subscription;
  private filledBallotsCounter: number;

  constructor(private router: Router,
              private route: ActivatedRoute,
              private voteWorkflowViewComponent: VoteWorkflowViewComponent,
              private currentVotingService: CurrentVotingService,
              private dialog: MatDialog) {
  }

  get votations(): Votation[] {
    return this.currentVotingService.votations;
  }

  get elections(): ElectionBallot[] {
    return this.currentVotingService.elections;
  }

  get groupVotation(): boolean {
    return this.currentVotingService.operation.groupVotation;
  }

  ngOnInit() {
    this.currentStepNumber &#x3D; this.voteWorkflowViewComponent.getStepNumber(Step.BallotList);
    this.nextStepNumber &#x3D; this.voteWorkflowViewComponent.getStepNumber(Step.Summary);

    this.changeSubscription &#x3D; this.currentVotingService.currentVotingChange.subscribe(() &#x3D;&gt; this.update());
    this.update()
    this.currentVotingService.lastVisitedPage &#x3D; &#x27;BALLOT_SELECTION&#x27;;
  }

  ngOnDestroy(): void {
    this.changeSubscription.unsubscribe();
  }

  quit(): void {
  }

  continue(): void {
    if (this.currentVotingService.participationCount() &#x3D;&#x3D;&#x3D; 0) {
      // at list one ballot should be filled
      this.dialog.open(ChvoteDialogComponent, {
        width: &#x27;500px&#x27;,
        disableClose: true,
        data: {
          messageKey: &#x27;ballot-list.dialog.participation-required&#x27;,
          primaryButtonKey: &#x27;global.actions.back&#x27;
        }
      });

    } else if (this.currentVotingService.participationCount() &lt; this.votations.length + this.elections.length) {
      // some ballots are not filled
      // display confirmation message
      this.dialog.open(ChvoteDialogComponent, {
        width: &#x27;500px&#x27;,
        disableClose: true,
        data: {
          messageKey: &#x27;ballot-list.dialog.confirm-participation&#x27;,
          primaryButtonKey: &#x27;ballot-list.dialog.confirm-participation-continue&#x27;,
          secondaryButtonKey: &#x27;global.actions.back&#x27;
        }
      }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
        if (accept) {
          this.router.navigate([&#x27;../summary&#x27;], {relativeTo: this.route});
        }
      });

    } else {
      this.router.navigate([&#x27;../summary&#x27;], {relativeTo: this.route});
    }
  }

  get counts() {
    return {
      totalBallotsCounter: this.totalBallotsCounter,
      filledBallotsCounter: this.filledBallotsCounter
    }
  }

  private get totalBallotsCounter() {
    let votationCount &#x3D; 0;
    if (this.votations.length &gt; 0) {
      votationCount &#x3D; (this.groupVotation) ? 1 : this.votations.length;
    }

    return votationCount + this.elections.length;
  }

  private update() {
    let votationCount &#x3D; this.countVoted(this.currentVotingService.votations);

    if (votationCount &gt; 0 &amp;&amp; this.groupVotation) {
      votationCount &#x3D; 1;
    }

    let electionCount &#x3D; this.countVoted(this.currentVotingService.elections);

    this.filledBallotsCounter &#x3D; votationCount + electionCount;
  }

  private countVoted&lt;Ballot extends ElectionBallot | Votation&gt;(ballots: Ballot[]) {
    return ballots.map(ballot &#x3D;&gt;
      this.currentVotingService.hasVotedFor(ballot)
    ).reduce((counter, hasVoted) &#x3D;&gt; counter + (hasVoted ? 1 : 0), 0)

  }
}
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-templateData">
        <pre class="line-numbers"><code class="language-html">&lt;!--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ~ /*                                                                                            ~
  ~  - #%L                                                                                        ~
  ~  - CHVote-Receiver                                                                            ~
  ~  - %%                                                                                         ~
  ~  - Copyright (C) 2016 - 2018 République et Canton de Genève                                   ~
  ~  - %%                                                                                         ~
  ~  - This program is free software: you can redistribute it and/or modify                       ~
  ~  - it under the terms of the GNU Affero General Public License as published by                ~
  ~  - the Free Software Foundation, either version 3 of the License, or                          ~
  ~  - (at your option) any later version.                                                        ~
  ~  -                                                                                            ~
  ~  - This program is distributed in the hope that it will be useful,                            ~
  ~  - but WITHOUT ANY WARRANTY; without even the implied warranty of                             ~
  ~  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                               ~
  ~  - GNU General Public License for more details.                                               ~
  ~  -                                                                                            ~
  ~  - You should have received a copy of the GNU Affero General Public License                   ~
  ~  - along with this program. If not, see &lt;http://www.gnu.org/licenses/&gt;.                       ~
  ~  - #L%                                                                                        ~
  ~  */                                                                                           ~
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--&gt;

&lt;vote-workflow-view&gt;&lt;/vote-workflow-view&gt;

&lt;h2 id&#x3D;&quot;stepTitle&quot;&gt;
  {{ &#x27;global.step.title-prefix&#x27; | translate:currentStepNumber }}
  {{ &#x27;ballot-list.step-name&#x27; | translate }}
&lt;/h2&gt;

&lt;section role&#x3D;&quot;document&quot; [innerHTML]&#x3D;&quot;&#x27;ballot-list.description&#x27; | translate:counts&quot;&gt;&lt;/section&gt;

&lt;section role&#x3D;&quot;main&quot;&gt;

  &lt;!-- elections --&gt;
  &lt;ng-container *ngIf&#x3D;&quot;elections.length &gt; 0&quot;&gt;
    &lt;h3 [innerHtml]&#x3D;&quot;&#x27;ballot-list.election.title&#x27; | translate&quot;&gt;&lt;/h3&gt;
    &lt;ul&gt;
      &lt;!--TODO: identify between proportional or majority ballot--&gt;
      &lt;li *ngFor&#x3D;&quot;let election of elections&quot; single-ballot-card
          [ballot]&#x3D;&quot;election&quot;
          type&#x3D;&quot;election-majority&quot;
          class&#x3D;&quot;ballot-card&quot;&gt;
      &lt;/li&gt;
    &lt;/ul&gt;
  &lt;/ng-container&gt;

  &lt;!-- votations --&gt;
  &lt;ng-container *ngIf&#x3D;&quot;votations.length &gt; 0&quot;&gt;
    &lt;h3 [innerHtml]&#x3D;&quot;&#x27;ballot-list.votation.title&#x27; | translate&quot;&gt;&lt;/h3&gt;
    &lt;ul *ngIf&#x3D;&quot;!groupVotation || votations.length &#x3D;&#x3D;&#x3D; 1&quot;&gt;
      &lt;li *ngFor&#x3D;&quot;let votation of votations&quot; single-ballot-card
          [ballot]&#x3D;&quot;votation&quot;
          type&#x3D;&quot;votation&quot;
          class&#x3D;&quot;ballot-card&quot;&gt;
      &lt;/li&gt;
    &lt;/ul&gt;
    &lt;div *ngIf&#x3D;&quot;groupVotation &amp;&amp; votations.length &gt; 1&quot; grouped-votation-card [ballots]&#x3D;&quot;votations&quot;&gt;&lt;/div&gt;
  &lt;/ng-container&gt;
&lt;/section&gt;

&lt;nav&gt;
  &lt;button mat-raised-button class&#x3D;&quot;abort&quot; (click)&#x3D;&quot;quit()&quot;&gt;
    &lt;i class&#x3D;&quot;fas fa-times&quot; data-fa-transform&#x3D;&quot;up-1 left-6&quot;&gt;&lt;/i&gt;
    {{ &#x27;global.actions.quit&#x27; | translate }}
  &lt;/button&gt;

  &lt;div class&#x3D;&quot;button-with-hint&quot;&gt;
    &lt;button mat-raised-button class&#x3D;&quot;primary&quot; (click)&#x3D;&quot;continue()&quot; id&#x3D;&quot;next-step-button&quot;
            aria-describedby&#x3D;&quot;next-step-hint&quot;&gt;
      {{ &#x27;global.actions.continue&#x27; | translate }}
      &lt;i class&#x3D;&quot;fas fa-arrow-right&quot; data-fa-transform&#x3D;&quot;up-1 right-6&quot;&gt;&lt;/i&gt;
    &lt;/button&gt;
    &lt;span id&#x3D;&quot;next-step-hint&quot; class&#x3D;&quot;next-step-hint&quot;&gt;
        {{ &#x27;global.step.next-info&#x27; | translate:nextStepNumber }}{{ &#x27;summary.step-name&#x27; | translate }}
    &lt;/span&gt;
  &lt;/div&gt;
&lt;/nav&gt;

</code></pre>
    </div>

    <div class="tab-pane fade " id="c-styleData">
                <p class="comment">
                    <code>./ballots-list.component.scss</code>
                </p>
                <pre class="line-numbers"><code class="language-scss">/*!*************************************************************************************************
 *                                                                                                *
 *  - #%L                                                                                         *
 *  - CHVote-Receiver                                                                             *
 *  - %%                                                                                          *
 *  - Copyright (C) 2016 - 2018 République et Canton de Genève                                    *
 *  - %%                                                                                          *
 *  - This program is free software: you can redistribute it and/or modify                        *
 *  - it under the terms of the GNU Affero General Public License as published by                 *
 *  - the Free Software Foundation, either version 3 of the License, or                           *
 *  - (at your option) any later version.                                                         *
 *  -                                                                                             *
 *  - This program is distributed in the hope that it will be useful,                             *
 *  - but WITHOUT ANY WARRANTY; without even the implied warranty of                              *
 *  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                *
 *  - GNU General Public License for more details.                                                *
 *  -                                                                                             *
 *  - You should have received a copy of the GNU Affero General Public License                    *
 *  - along with this program. If not, see &lt;http://www.gnu.org/licenses/&gt;.                        *
 *  - #L%                                                                                         *
 *                                                                                                *
 **************************************************************************************************/

ul {
  list-style: none;
  padding: 0;
  margin: 0;
}

.ballot-card:not(:last-child) {
  margin-bottom: 20px;
}
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-tree">
        <div id="tree-container"></div>
        <div class="tree-legend">
            <div class="title">
                <b>Legend</b>
            </div>
            <div>
                <div class="color htmlelement"></div><span>Html element</span>
            </div>
            <div>
                <div class="color component"></div><span>Component</span>
            </div>
            <div>
                <div class="color directive"></div><span>Html element with directive</span>
            </div>
        </div>
    </div>

    
</div>

<script src="../js/libs/vis.min.js"></script>
<script src="../js/libs/htmlparser.js"></script>
<script src="../js/libs/deep-iterator.js"></script>
<script>
        var COMPONENT_TEMPLATE = '<div><!--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  ~ /*                                                                                            ~  ~  - #%L                                                                                        ~  ~  - CHVote-Receiver                                                                            ~  ~  - %%                                                                                         ~  ~  - Copyright (C) 2016 - 2018 République et Canton de Genève                                   ~  ~  - %%                                                                                         ~  ~  - This program is free software: you can redistribute it and/or modify                       ~  ~  - it under the terms of the GNU Affero General Public License as published by                ~  ~  - the Free Software Foundation, either version 3 of the License, or                          ~  ~  - (at your option) any later version.                                                        ~  ~  -                                                                                            ~  ~  - This program is distributed in the hope that it will be useful,                            ~  ~  - but WITHOUT ANY WARRANTY; without even the implied warranty of                             ~  ~  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                               ~  ~  - GNU General Public License for more details.                                               ~  ~  -                                                                                            ~  ~  - You should have received a copy of the GNU Affero General Public License                   ~  ~  - along with this program. If not, see <http://www.gnu.org/licenses/>.                       ~  ~  - #L%                                                                                        ~  ~  */                                                                                           ~  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--><vote-workflow-view></vote-workflow-view><h2 id="stepTitle">  {{ \'global.step.title-prefix\' | translate:currentStepNumber }}  {{ \'ballot-list.step-name\' | translate }}</h2><section role="document" [innerHTML]="\'ballot-list.description\' | translate:counts"></section><section role="main">  <!-- elections -->  <ng-container *ngIf="elections.length > 0">    <h3 [innerHtml]="\'ballot-list.election.title\' | translate"></h3>    <ul>      <!--TODO: identify between proportional or majority ballot-->      <li *ngFor="let election of elections" single-ballot-card          [ballot]="election"          type="election-majority"          class="ballot-card">      </li>    </ul>  </ng-container>  <!-- votations -->  <ng-container *ngIf="votations.length > 0">    <h3 [innerHtml]="\'ballot-list.votation.title\' | translate"></h3>    <ul *ngIf="!groupVotation || votations.length === 1">      <li *ngFor="let votation of votations" single-ballot-card          [ballot]="votation"          type="votation"          class="ballot-card">      </li>    </ul>    <div *ngIf="groupVotation && votations.length > 1" grouped-votation-card [ballots]="votations"></div>  </ng-container></section><nav>  <button mat-raised-button class="abort" (click)="quit()">    <i class="fas fa-times" data-fa-transform="up-1 left-6"></i>    {{ \'global.actions.quit\' | translate }}  </button>  <div class="button-with-hint">    <button mat-raised-button class="primary" (click)="continue()" id="next-step-button"            aria-describedby="next-step-hint">      {{ \'global.actions.continue\' | translate }}      <i class="fas fa-arrow-right" data-fa-transform="up-1 right-6"></i>    </button>    <span id="next-step-hint" class="next-step-hint">        {{ \'global.step.next-info\' | translate:nextStepNumber }}{{ \'summary.step-name\' | translate }}    </span>  </div></nav></div>'
    var COMPONENTS = [{'name': 'ActionsOnBallotsComponent', 'selector': 'actions-on-ballots'},{'name': 'AppComponent', 'selector': 'app-root'},{'name': 'BallotsListComponent', 'selector': 'app-ballots-list'},{'name': 'BusinessErrorDialogComponent', 'selector': 'app-business-error-dialog'},{'name': 'ChvoteBallotHeaderComponent', 'selector': 'chvote-ballot-header'},{'name': 'ChvoteCheckboxComponent', 'selector': 'chvote-checkbox'},{'name': 'ChvoteCoatOfArmsComponent', 'selector': 'chvote-coat-of-arms'},{'name': 'ChvoteDialogComponent', 'selector': 'chvote-dialog'},{'name': 'ChvoteDocumentsComponent', 'selector': 'chvote-documents'},{'name': 'ChvoteExpansionPanelComponent', 'selector': 'chvote-expansion-panel'},{'name': 'ChvoteHelperComponent', 'selector': 'chvote-helper'},{'name': 'ChvoteSubjectCardComponent', 'selector': '[chvote-subject-card]'},{'name': 'ChvoteVariantSubjectCardComponent', 'selector': '[chvote-variant-subject-card]'},{'name': 'ChvoteVotationBallotComponent', 'selector': 'chvote-votation-ballot'},{'name': 'ControlComponent', 'selector': 'control, [control]'},{'name': 'DefaultErrorsComponent', 'selector': 'default-errors'},{'name': 'ErrorMessageComponent', 'selector': 'error-message-component'},{'name': 'FinalizationComponent', 'selector': 'finalization, [finalization]'},{'name': 'FooterDocumentsComponent', 'selector': 'footer-documents'},{'name': 'FooterZoneComponent', 'selector': 'footer-zone'},{'name': 'GroupedVotationCardComponent', 'selector': '[grouped-votation-card]'},{'name': 'HeaderZoneComponent', 'selector': 'header-zone'},{'name': 'IdentificationComponent', 'selector': ''},{'name': 'LegalInformationComponent', 'selector': ''},{'name': 'LocalizedLabelComponent', 'selector': '[localized-label]'},{'name': 'OperationComponent', 'selector': ''},{'name': 'SideZoneComponent', 'selector': 'side-zone'},{'name': 'SideZoneSectionComponent', 'selector': 'side-zone-section'},{'name': 'SingleBallotCardComponent', 'selector': '[single-ballot-card]'},{'name': 'SummaryComponent', 'selector': 'summary, [summary]'},{'name': 'TechnicalErrorDialogComponent', 'selector': 'app-technical-error-dialog'},{'name': 'VotationBallotComponent', 'selector': 'votation-ballot, [votation-ballot]'},{'name': 'VotationCardComponent', 'selector': '[votation-card]'},{'name': 'VoteWorkflowStepComponent', 'selector': 'li[vote-workflow-step]'},{'name': 'VoteWorkflowViewComponent', 'selector': 'vote-workflow-view'}];
    var DIRECTIVES = [];
    var ACTUAL_COMPONENT = {'name': 'BallotsListComponent'};
</script>
<script src="../js/tree.js"></script>














                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'component';
            var COMPODOC_CURRENT_PAGE_URL = 'BallotsListComponent.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
